Subject: RE: Transport requirements for NFSv4

From: "Noveck, Dave" <[email-masked]>
Date: Fri, 5 Nov 1999 07:20:52 -0800

> > Mike Eisler wrote:
> > > Neither do the TCP requirements have anything to to with 
> NFSv4. But if we
> > > specify TCP, we have to specify the network protocol, 
> which is going to be IP.
> > > So which IP?
> > 
> > It doesn't matter - NFSv4 will run fine over any IP.
> 
> But an NFSv4 over TCP/IPv6 won't necessarily interoperate 
> with a an NFSv4 over
> TCP/IPv6. So if we don't care about that, why do we care if 
> it runs over TCP
> at all? Marketing?

No, Fear.

I think you just told us why we care about it running over TCP.
I believe it was because you didn't want to find out what ...
means.  I don't either.

The TCP/IPv4-TCP/IPv6 interoperability issue is going to exist
in any case.  You can't (unconditionally) make everyone who
want to implement NFSv4, implement IPv6.

I don't see being so draconian about it.  If we have to make
a statement about IPv4-IPv6, how about this?

You MUST implement NFSv4 over TCP/IPv4 or over TCP/IPv6.

If your network stack implements TCP/IPv4, you SHOULD implement
NFSv4 over TCP/IPv4.

If your network stack implements TCP/IPv6, you SHOULD implement
NFSv4 over TCP/IPv6.

> 
> > The NFSv4 standard must not be used as a soapbox to
> > dictate the IP version.
> 
> NFSv4 shouldn't be used as a soap box to dictate the 
> transport either. (There
> are quite a few people who would substitue "IP version" for 
> "security".) But,
> just as with security, a well known big rule, apparently we 
> have to dictate the
> transport (aparently a lesser known big rule), so we need to 
> completely
> describe the transport we are dictating.

But we can't completely describe the transport we are dictating.

You MUST implement on TCP/IPv4, seems a bit old-fashioned.

You MUST implement on TCP/IPv6 just won't fly.  Too many 
people don't have IPv6.

>  
> If the issue is simply concern about NFSv4 causing all kinds 
> of congestion,
> then why don't we simply state that NFSv4 MUST be offered 
> over a connection
> oriented transport, such as TCP, and the client MUST prefer to use a
> connection oriented transport. 
 
As I understand it, someone is making us do the TCP thing, but
nobody so far is making us do the IPv6 thing.

If it is a good thing for people to "get with the program"
and implement IPv6, adding to the cost of getting it out
the door with additional requirements doesn't help people
get with the program.  It hurts.